<?php
/*
=============================================
Движок: SHCMS Engine
=============================================
Название файла: Errors
=============================================
Official website: http://shcms.ru
=============================================
*/
define('SHCMS', true);
include_once'system/inc/basic_settings.php';
$shcmsengine['title'] = 'Ошибка';

include_once'template/head.php';


$erro_s = $_SERVER['REDIRECT_STATUS'];
$errors_list = 
       array(
       400 => array('400 Плохой запрос', 'Запрос не может быть обработан из-за синтаксической ошибки.'),
       403 => array('403 Запрещено', 'Сервер отказывает в выполнении вашего запроса.'),
       404 => array('404 Не найдено', 'Запрашиваемая страница не найдена на сервере.'),
       405 => array('405 Метод не допускается', 'Указанный в запросе метод не допускается для заданного ресурса.'),
       408 => array('408 Время ожидания истекло', 'Ваш браузер не отправил информацию на сервер за отведенное время.'),
       500 => array('500 Внутренняя ошибка сервера', 'Запрос не может быть обработан из-за внутренней ошибки сервера.'),
       502 => array('502 Плохой шлюз', 'Сервер получил неправильный ответ при попытке передачи запроса.'),
       504 => array('504 Истекло время ожидания шлюза', 'Вышестоящий сервер не ответил за установленное время.'),
       );
 
$title_names = $errors_list[$erro_s][0];
$message_errors = $errors_list[$erro_s][1];
if ($title_names == false || strlen($erro_s) != 3) {
       $message_errors = 'Код ошибки HTTP не правильный.';
}
 
echo '<h3>Внимание! Обнаружена ошибка '.$title_names.'!</h3>
<p>'.$message_errors.'</p><div class="posts">
<a href="javascript:history.back()" title="Вернуться на предыдущую страницу" >Вернуться назад</a></div>
';



include_once'template/foot.php';
?>